<template>
	<b-form inline>
		<b-form-select
			id="ddlTermSelectorSemester"
			class="mr-2"
			:options="options"
			v-model="semester"
			:state="semesterState"
			v-on:change="onSemesterChange"
			label="Term"
		></b-form-select>
		<b-form-invalid-feedback
			v-show="!semesterState"
			id="ddlTermSelectorSemester"
			class="mb-sm-3"
		>
			Semester is required, please select one
		</b-form-invalid-feedback>

		<label for="txtTermSelectorYear" class="sr-only">Year</label>
		<b-form-input
			class="mt-2 mr-2 mt-sm-0"
			id="txtTermSelectorYear"
			v-model="year"
			type="number"
			placeholder="Year"
			v-on:change="onYearChange"
			:state="yearState"
			v-on:keydown.enter.stop.prevent
		></b-form-input>
		<b-form-text class="mb-2 mr-sm-2 mb-sm-0">{{ termDisplay }}</b-form-text>
		<b-form-invalid-feedback
			class="mb-2 mr-sm-2 mb-sm-0"
			v-show="!yearState"
			id="txtTermSelectorYear"
		>
			Term needs to be a valid year between 2010-2098
		</b-form-invalid-feedback>
		<br />
	</b-form>
</template>

<script>
import { mapGetters, mapMutations } from "vuex";

export default {
	props: {
		value: {
			type: String,
			required: true
		},
		allowEmpty: {
			type: Boolean,
			default: false
		},
		populate_globally_selected_term: {
			type: Boolean,
			default: true
		}
	},
	model: {
		prop: "value",
		event: "change"
	},
	data() {
		return {
			options: [
				{ text: "Semester", value: null },
				{ text: "Fall", value: "10" },
				{ text: "Spring", value: "20" },
				{ text: "Summer", value: "30" }
			],
			local_semester: "",
			local_year: ""
		};
	},
	computed: {
		...mapGetters({
			termSelector_semester_visited: "semester_visited",
			termSelector_year_visited: "year_visited",
			termSelector_semester: "semester",
			termSelector_year: "year"
		}),
		semester: {
			get() {
				return this.local_semester;
			},
			set(value) {
				this.local_semester = value;
				if (!(this.populate_globally_selected_term === false)) {
					this.set_termSelector_semester(value);
				}
			}
		},
		year: {
			get() {
				return this.local_year;
			},
			set(value) {
				this.local_year = value;
				if (!(this.populate_globally_selected_term === false)) {
					this.set_termSelector_year(value);
				}
			}
		},
		yearVisited: {
			get: function() {
				return this.termSelector_year_visited;
			},
			set: function(newValue) {
				this.set_termSelector_year_visited(newValue);
			}
		},
		semesterVisited: {
			get: function() {
				return this.termSelector_semester_visited;
			},
			set: function(newValue) {
				this.set_termSelector_semester_visited(newValue);
			}
		},
		term() {
			if (this.local_year.length !== 4 || this.local_semester === null) {
				return "";
			}

			let year = parseInt(this.local_year);
			if (this.local_semester === "10") {
				year += 1;
			}

			return year.toString().substr(2) + this.local_semester;
		},
		termDisplay() {
			if (this.term.length > 0) {
				return "MaineStreet Identifier: " + this.term;
			}

			return "";
		},
		yearState() {
			if (this.allowEmpty && this.local_year === "") {
				return null;
			}

			if (!this.yearVisited) {
				return null;
			}

			if (this.local_year.length !== 4) {
				return false;
			}
			return !(
				parseInt(this.local_year) < 2010 || parseInt(this.local_year) > 2098
			);
		},
		semesterState() {
			if (this.allowEmpty && this.local_semester === null) {
				return null;
			}

			if (!this.semesterVisited) {
				return null;
			}

			return this.local_semester !== null;
		}
	},
	methods: {
		...mapMutations({
			set_termSelector_semester_visited: "set_semester_visited",
			set_termSelector_year_visited: "set_year_visited",
			set_termSelector_semester: "set_semester",
			set_termSelector_year: "set_year",
			set_termSelector_term: "set_term"
		}),
		onSemesterChange() {
			this.semesterVisited = true;
			if (!(this.populate_globally_selected_term === false)) {
				this.set_termSelector_term(this.term);
			}
			this.$emit("change", this.term);
		},
		onYearChange() {
			this.yearVisited = true;
			if (!(this.populate_globally_selected_term === false)) {
				this.set_termSelector_term(this.term);
			}
			this.$emit("change", this.term);
		}
	},
	mounted() {
		this.local_year = this.termSelector_year;
		this.local_semester = this.termSelector_semester;

		if (this.local_year.length < 1 && !this.allowEmpty) {
			this.local_year = new Date().getFullYear().toString();
		}
	}
};
</script>
